diff --git a/sys/contrib/dev/acpica/source/tools/acpihelp/ahdecode.c b/sys/contrib/dev/acpica/source/tools/acpihelp/ahdecode.c
index 556dc6c..60e3808 100644
--- a/sys/contrib/dev/acpica/source/tools/acpihelp/ahdecode.c
+++ b/sys/contrib/dev/acpica/source/tools/acpihelp/ahdecode.c
@@ -48,41 +48,6 @@
 #include "acpredef.h"
 
 
-/* Device IDs defined in the ACPI specification */
-
-static const AH_DEVICE_ID  AhDeviceIds[] =
-{
-    {"PNP0A05",     "Generic Container Device"},
-    {"PNP0A06",     "Generic Container Device"},
-    {"PNP0C08",     "ACPI core hardware"},
-    {"PNP0C09",     "Embedded Controller Device"},
-    {"PNP0C0A",     "Control Method Battery"},
-    {"PNP0C0B",     "Fan"},
-    {"PNP0C0C",     "Power Button Device"},
-    {"PNP0C0D",     "Lid Device"},
-    {"PNP0C0E",     "Sleep Button Device"},
-    {"PNP0C0F",     "PCI Interrupt Link Device"},
-    {"PNP0C80",     "Memory Device"},
-
-    {"ACPI0001",    "SMBus 1.0 Host Controller"},
-    {"ACPI0002",    "Smart Battery Subsystem"},
-    {"ACPI0003",    "Power Source Device"},
-    {"ACPI0004",    "Module Device"},
-    {"ACPI0005",    "SMBus 2.0 Host Controller"},
-    {"ACPI0006",    "GPE Block Device"},
-    {"ACPI0007",    "Processor Device"},
-    {"ACPI0008",    "Ambient Light Sensor Device"},
-    {"ACPI0009",    "I/O xAPIC Device"},
-    {"ACPI000A",    "I/O APIC Device"},
-    {"ACPI000B",    "I/O SAPIC Device"},
-    {"ACPI000C",    "Processor Aggregator Device"},
-    {"ACPI000D",    "Power Meter Device"},
-    {"ACPI000E",    "Time/Alarm Device"},
-    {"ACPI000F",    "User Presence Detection Device"},
-
-    {NULL, NULL}
-};
-
 #define AH_DISPLAY_EXCEPTION(Status, Name) \
     printf ("%.4X: %s\n", Status, Name)
 
@@ -589,7 +554,7 @@ AhDisplayAslKeyword (
 
 /*******************************************************************************
  *
- * FUNCTION:    AhFindAslOperators (entry point for ASL operator search)
+ * FUNCTION:    AhFindAslAndAmlOperators
  *
  * PARAMETERS:  Name                - Name or prefix for an ASL operator.
  *                                    NULL means "find all"
@@ -597,16 +562,46 @@ AhDisplayAslKeyword (
  * RETURN:      None
  *
  * DESCRIPTION: Find all ASL operators that match the input Name or name
- *              prefix.
+ *              prefix. Also displays the AML information if only one entry
+ *              matches.
  *
  ******************************************************************************/
 
 void
+AhFindAslAndAmlOperators (
+    char                    *Name)
+{
+    UINT32                  MatchCount;
+
+
+    MatchCount = AhFindAslOperators (Name);
+    if (MatchCount == 1)
+    {
+        AhFindAmlOpcode (Name);
+    }
+}
+
+
+/*******************************************************************************
+ *
+ * FUNCTION:    AhFindAslOperators (entry point for ASL operator search)
+ *
+ * PARAMETERS:  Name                - Name or prefix for an ASL operator.
+ *                                    NULL means "find all"
+ *
+ * RETURN:      Number of operators that matched the name prefix.
+ *
+ * DESCRIPTION: Find all ASL operators that match the input Name or name
+ *              prefix.
+ *
+ ******************************************************************************/
+
+UINT32
 AhFindAslOperators (
     char                    *Name)
 {
     const AH_ASL_OPERATOR   *Operator;
-    BOOLEAN                 Found = FALSE;
+    BOOLEAN                 MatchCount = 0;
 
 
     AhStrupr (Name);
@@ -618,7 +613,7 @@ AhFindAslOperators (
         if (!Name)
         {
             AhDisplayAslOperator (Operator);
-            Found = TRUE;
+            MatchCount++;
             continue;
         }
 
@@ -630,14 +625,16 @@ AhFindAslOperators (
         if (strstr (Gbl_Buffer, Name) == Gbl_Buffer)
         {
             AhDisplayAslOperator (Operator);
-            Found = TRUE;
+            MatchCount++;
         }
     }
 
-    if (!Found)
+    if (!MatchCount)
     {
         printf ("%s, no matching ASL operators\n", Name);
     }
+
+    return (MatchCount);
 }
 
 
@@ -805,26 +802,71 @@ AhPrintOneField (
  *
  * FUNCTION:    AhDisplayDeviceIds
  *
- * PARAMETERS:  None
+ * PARAMETERS:  Name                - Device Hardware ID string.
+ *                                    NULL means "find all"
  *
  * RETURN:      None
  *
- * DESCRIPTION: Display all PNP* and ACPI* device IDs defined in the ACPI spec.
+ * DESCRIPTION: Display PNP* and ACPI* device IDs.
  *
  ******************************************************************************/
 
 void
 AhDisplayDeviceIds (
-    void)
+    char                    *Name)
 {
-    const AH_DEVICE_ID      *DeviceId = AhDeviceIds;
+    const AH_DEVICE_ID      *Info;
+    UINT32                  Length;
+    BOOLEAN                 Matched;
+    UINT32                  i;
+    BOOLEAN                 Found = FALSE;
+
+
+    /* Null input name indicates "display all" */
+
+    if (!Name)
+    {
+        printf ("ACPI and PNP Device/Hardware IDs:\n\n");
+        for (Info = AslDeviceIds; Info->Name; Info++)
+        {
+            printf ("%8s   %s\n", Info->Name, Info->Description);
+        }
+
+        return;
+    }
 
+    Length = strlen (Name);
+    if (Length > 8)
+    {
+        printf ("%.8s: Hardware ID must be 8 characters maximum\n", Name);
+        return;
+    }
 
-    printf ("ACPI and PNP Device IDs defined in the ACPI specification:\n\n");
-    while (DeviceId->Name)
+    /* Find/display all names that match the input name prefix */
+
+    AhStrupr (Name);
+    for (Info = AslDeviceIds; Info->Name; Info++)
+    {
+        Matched = TRUE;
+        for (i = 0; i < Length; i++)
+        {
+            if (Info->Name[i] != Name[i])
+            {
+                Matched = FALSE;
+                break;
+            }
+        }
+
+        if (Matched)
+        {
+            Found = TRUE;
+            printf ("%8s   %s\n", Info->Name, Info->Description);
+        }
+    }
+
+    if (!Found)
     {
-        printf ("%8s   %s\n", DeviceId->Name, DeviceId->Description);
-        DeviceId++;
+        printf ("%s, Hardware ID not found\n", Name);
     }
 }
 
diff --git a/sys/contrib/dev/acpica/source/tools/acpihelp/ahmain.c b/sys/contrib/dev/acpica/source/tools/acpihelp/ahmain.c
index 1a8de1e..a340598 100644
--- a/sys/contrib/dev/acpica/source/tools/acpihelp/ahmain.c
+++ b/sys/contrib/dev/acpica/source/tools/acpihelp/ahmain.c
@@ -51,7 +51,7 @@ AhDisplayUsage (
     void);
 
 #define AH_UTILITY_NAME             "ACPI Help Utility"
-#define AH_SUPPORTED_OPTIONS        "ehikmopsv"
+#define AH_SUPPORTED_OPTIONS        "aehikmopsv"
 
 
 /******************************************************************************
@@ -67,24 +67,29 @@ AhDisplayUsage (
     void)
 {
 
-    ACPI_USAGE_HEADER ("acpihelp <options> [NamePrefix | HexValue]");
+    ACPI_USAGE_HEADER ("acpihelp <options> [Name/Prefix | HexValue]");
     ACPI_OPTION ("-h",                      "Display help");
     ACPI_OPTION ("-v",                      "Display version information");
 
-    printf ("\nACPI Names and Symbols:\n");
-    ACPI_OPTION ("-k [NamePrefix]",         "Find/Display ASL non-operator keyword(s)");
-    ACPI_OPTION ("-m [NamePrefix]",         "Find/Display AML opcode name(s)");
-    ACPI_OPTION ("-p [NamePrefix]",         "Find/Display ASL predefined method name(s)");
-    ACPI_OPTION ("-s [NamePrefix]",         "Find/Display ASL operator name(s)");
+    printf ("\nAML (ACPI Machine Language) Names and Encodings:\n");
+    ACPI_OPTION ("-a [Name/Prefix]",        "Find/Display both ASL operator and AML opcode name(s)");
+    ACPI_OPTION ("-m [Name/Prefix]",        "Find/Display AML opcode name(s)");
+
+    printf ("\nASL (ACPI Source Language) Names and Symbols:\n");
+    ACPI_OPTION ("-k [Name/Prefix]",        "Find/Display ASL non-operator keyword(s)");
+    ACPI_OPTION ("-p [Name/Prefix]",        "Find/Display ASL predefined method name(s)");
+    ACPI_OPTION ("-s [Name/Prefix]",        "Find/Display ASL operator name(s)");
+
+    printf ("\nOther ACPI Names:\n");
+    ACPI_OPTION ("-i [Name/Prefix]",        "Find/Display ACPI/PNP Hardware ID(s)");
 
     printf ("\nACPI Values:\n");
     ACPI_OPTION ("-e [HexValue]",           "Decode ACPICA exception code");
-    ACPI_OPTION ("-i",                      "Display known ACPI Device IDs (_HID)");
     ACPI_OPTION ("-o [HexValue]",           "Decode hex AML opcode");
 
-    printf ("\nNamePrefix/HexValue not specified means \"Display All\"\n");
-    printf ("\nDefault search with NamePrefix and no options:\n");
-    printf ("    Find ASL operator names - if NamePrefix does not start with underscore\n");
+    printf ("\nName/Prefix or HexValue not specified means \"Display All\"\n");
+    printf ("\nDefault search with valid Name/Prefix and no options:\n");
+    printf ("    Find ASL/AML operator names - if NamePrefix does not start with underscore\n");
     printf ("    Find ASL predefined method names - if NamePrefix starts with underscore\n");
 }
 
@@ -121,6 +126,11 @@ main (
 
     while ((j = AcpiGetopt (argc, argv, AH_SUPPORTED_OPTIONS)) != EOF) switch (j)
     {
+    case 'a':
+
+        DecodeType = AH_DECODE_ASL_AML;
+        break;
+
     case 'e':
 
         DecodeType = AH_DECODE_EXCEPTION;
@@ -173,6 +183,11 @@ main (
 
     switch (DecodeType)
     {
+    case AH_DECODE_ASL_AML:
+
+        AhFindAslAndAmlOperators (Name);
+        break;
+
     case AH_DECODE_AML:
 
         AhFindAmlOpcode (Name);
@@ -200,7 +215,7 @@ main (
 
     case AH_DISPLAY_DEVICE_IDS:
 
-        AhDisplayDeviceIds ();
+        AhDisplayDeviceIds (Name);
         break;
 
     case AH_DECODE_EXCEPTION:
@@ -222,7 +237,7 @@ main (
         }
         else
         {
-            AhFindAslOperators (Name);
+            AhFindAslAndAmlOperators (Name);
         }
         break;
     }
diff --git a/sys/contrib/dev/acpica/source/tools/acpisrc/asfile.c b/sys/contrib/dev/acpica/source/tools/acpisrc/asfile.c
index 42cefa4..d3b72de 100644
--- a/sys/contrib/dev/acpica/source/tools/acpisrc/asfile.c
+++ b/sys/contrib/dev/acpica/source/tools/acpisrc/asfile.c
@@ -42,6 +42,7 @@
  */
 
 #include "acpisrc.h"
+#include "acapps.h"
 
 /* Local prototypes */
 
@@ -714,8 +715,6 @@ AsGetFile (
     FILE                    *File;
     UINT32                  Size;
     char                    *Buffer;
-    int                     Seek1;
-    int                     Seek2;
     size_t                  Actual;
 
 
@@ -730,11 +729,8 @@ AsGetFile (
 
     /* Need file size to allocate a buffer */
 
-    Seek1 = fseek (File, 0L, SEEK_END);
-    Size = ftell (File);
-    Seek2 = fseek (File, 0L, SEEK_SET);
-
-    if (Seek1 || Seek2 || (Size == -1))
+    Size = CmGetFileSize (File);
+    if (Size == ACPI_UINT32_MAX)
     {
         printf ("Could not get file size for %s\n", Filename);
         goto ErrorExit;
diff --git a/sys/contrib/dev/acpica/source/tools/acpisrc/astable.c b/sys/contrib/dev/acpica/source/tools/acpisrc/astable.c
index 7c3d663..0073128 100644
--- a/sys/contrib/dev/acpica/source/tools/acpisrc/astable.c
+++ b/sys/contrib/dev/acpica/source/tools/acpisrc/astable.c
@@ -637,6 +637,10 @@ ACPI_TYPED_IDENTIFIER_TABLE           AcpiIdentifiers[] = {
     {"PR_MACRO_ARG",                        SRC_TYPE_STRUCT},
     {"PR_OPERATOR_INFO",                    SRC_TYPE_STRUCT},
 
+    /* AcpiDump utility */
+
+    {"AP_DUMP_ACTION",                      SRC_TYPE_STRUCT},
+
     /* AcpiHelp utility */
 
     {"AH_AML_OPCODE",                       SRC_TYPE_STRUCT},
@@ -648,6 +652,11 @@ ACPI_TYPED_IDENTIFIER_TABLE           AcpiIdentifiers[] = {
 
     {"AX_TABLE_INFO",                       SRC_TYPE_STRUCT},
 
+    /* OS service layers */
+
+    {"EXTERNAL_FIND_INFO",                  SRC_TYPE_STRUCT},
+    {"OSL_TABLE_INFO",                      SRC_TYPE_STRUCT},
+
     {NULL, 0}
 };
 
diff --git a/sys/dev/acpica/Makefile b/sys/dev/acpica/Makefile
index 760c632..d1f2c4e 100644
--- a/sys/dev/acpica/Makefile
+++ b/sys/dev/acpica/Makefile
@@ -30,6 +30,7 @@ CFLAGS+=	-DACPI_DEBUG_CACHE
 KMOD	= acpi
 
 # ACPI CA sources
+SRCS+=	ahids.c
 SRCS+=	dbcmds.c dbconvert.c dbdisply.c dbexec.c dbfileio.c dbhistry.c
 SRCS+=	dbinput.c dbstats.c dbtest.c dbutils.c dbxface.c
 SRCS+=	dbmethod.c dbnames.c
@@ -55,7 +56,7 @@ SRCS+=	psargs.c psloop.c psobject.c psopcode.c psopinfo.c psparse.c psscope.c
 SRCS+=	pstree.c psutils.c pswalk.c psxface.c
 SRCS+=	rsaddr.c rscalc.c rscreate.c rsdump.c rsdumpinfo.c rsinfo.c rsio.c
 SRCS+=	rsirq.c rslist.c rsmemory.c rsmisc.c rsserial.c rsutils.c
-SRCS+=	rsxface.c tbfadt.c tbfind.c tbinstal.c tbprint.c
+SRCS+=	rsxface.c tbdata.c tbfadt.c tbfind.c tbinstal.c tbprint.c
 SRCS+=	tbutils.c tbxface.c tbxfload.c tbxfroot.c utalloc.c utbuffer.c
 SRCS+=	utaddress.c utclib.c utcopy.c
 SRCS+=	utdebug.c utdelete.c uterror.c uteval.c utexcep.c
diff --git a/sys/dev/acpica/Osd/OsdSchedule.c b/sys/dev/acpica/Osd/OsdSchedule.c
index 6a3c584..67827f8 100644
--- a/sys/dev/acpica/Osd/OsdSchedule.c
+++ b/sys/dev/acpica/Osd/OsdSchedule.c
@@ -147,6 +147,14 @@ AcpiOsExecute(ACPI_EXECUTE_TYPE Type, ACPI_OSD_EXEC_CALLBACK Function,
 }
 
 /*
+ * XXX
+ */
+void
+AcpiOsWaitEventsComplete(void)
+{
+}
+
+/*
  * The message's reply port just frees the message.
  */
 static void
diff --git a/sys/dev/acpica/Osd/OsdTable.c b/sys/dev/acpica/Osd/OsdTable.c
index 104b9f7..5ef0b54 100644
--- a/sys/dev/acpica/Osd/OsdTable.c
+++ b/sys/dev/acpica/Osd/OsdTable.c
@@ -80,3 +80,12 @@ AcpiOsTableOverride (
     kprintf("ACPI: DSDT was overridden.\n");
     return (AE_OK);
 }
+
+ACPI_STATUS
+AcpiOsPhysicalTableOverride(
+    ACPI_TABLE_HEADER		*ExistingTable,
+    ACPI_PHYSICAL_ADDRESS	*NewAddress,
+    UINT32			*NewTableLength)
+{
+	return (AE_SUPPORT);
+}
diff --git a/usr.sbin/acpi/acpibin/Makefile b/usr.sbin/acpi/acpibin/Makefile
index b068b7e..7fee615 100644
--- a/usr.sbin/acpi/acpibin/Makefile
+++ b/usr.sbin/acpi/acpibin/Makefile
@@ -14,6 +14,8 @@ SRCS=	\
 	abmain.c
 
 SRCS+=	\
+	cmfsize.c \
+	getopt.c \
 	utalloc.c \
 	utbuffer.c \
 	utcache.c \
@@ -27,8 +29,7 @@ SRCS+=	\
 	utstate.c \
 	utstring.c \
 	utxferror.c \
-	osunixxf.c \
-	getopt.c
+	osunixxf.c
 
 CFLAGS+= \
 	-DACPI_BIN_APP \
diff --git a/usr.sbin/acpi/acpidump/Makefile b/usr.sbin/acpi/acpidump/Makefile
index 23f9080..edd3dd0 100644
--- a/usr.sbin/acpi/acpidump/Makefile
+++ b/usr.sbin/acpi/acpidump/Makefile
@@ -15,6 +15,8 @@ SRCS=	\
 	apmain.c
 
 SRCS+=	\
+	cmfsize.c \
+	getopt.c \
 	osunixdir.c \
 	osunixmap.c \
 	tbprint.c \
@@ -23,8 +25,7 @@ SRCS+=	\
 	utexcep.c \
 	utmath.c \
 	utstring.c \
-	utxferror.c \
-	getopt.c
+	utxferror.c
 
 SRCS+=	\
 	osdragonflytbl.c
diff --git a/usr.sbin/acpi/acpiexec/Makefile b/usr.sbin/acpi/acpiexec/Makefile
index d8c9c0f..513b282 100644
--- a/usr.sbin/acpi/acpiexec/Makefile
+++ b/usr.sbin/acpi/acpiexec/Makefile
@@ -19,6 +19,8 @@ SRCS=	\
 
 SRCS+=	\
 	acgetline.c \
+	ahids.c \
+	cmfsize.c \
 	dbcmds.c \
 	dbconvert.c \
 	dbdisply.c \
@@ -154,6 +156,7 @@ SRCS+=	\
 	rsserial.c \
 	rsutils.c \
 	rsxface.c \
+	tbdata.c \
 	tbfadt.c \
 	tbfind.c \
 	tbinstal.c \
diff --git a/usr.sbin/acpi/acpihelp/Makefile b/usr.sbin/acpi/acpihelp/Makefile
index a826952..2f03561 100644
--- a/usr.sbin/acpi/acpihelp/Makefile
+++ b/usr.sbin/acpi/acpihelp/Makefile
@@ -15,6 +15,7 @@ SRCS=	\
 	ahaslkey.c \
 	ahaslops.c \
 	ahdecode.c \
+	ahids.c \
 	ahpredef.c \
 	ahmain.c
 
diff --git a/usr.sbin/acpi/acpinames/Makefile b/usr.sbin/acpi/acpinames/Makefile
index dccb5ae..b128455 100644
--- a/usr.sbin/acpi/acpinames/Makefile
+++ b/usr.sbin/acpi/acpinames/Makefile
@@ -17,6 +17,7 @@ SRCS=	\
 	antables.c
 
 SRCS+=	\
+	cmfsize.c \
 	dbfileio.c \
 	dsfield.c \
 	dsmthdat.c \
@@ -58,6 +59,7 @@ SRCS+=	\
 	psutils.c \
 	pswalk.c \
 	psxface.c \
+	tbdata.c \
 	tbfadt.c \
 	tbfind.c \
 	tbinstal.c \
diff --git a/usr.sbin/acpi/acpisrc/Makefile b/usr.sbin/acpi/acpisrc/Makefile
index 769261e..236f741 100644
--- a/usr.sbin/acpi/acpisrc/Makefile
+++ b/usr.sbin/acpi/acpisrc/Makefile
@@ -19,8 +19,9 @@ SRCS=	\
 	asutils.c
 
 SRCS+=	\
-	osunixdir.c \
-	getopt.c
+	cmfsize.c \
+	getopt.c \
+	osunixdir.c
 
 CFLAGS+= \
 	-DACPI_SRC_APP \
diff --git a/usr.sbin/acpi/iasl/Makefile b/usr.sbin/acpi/iasl/Makefile
index 9c00601..c558c40 100644
--- a/usr.sbin/acpi/iasl/Makefile
+++ b/usr.sbin/acpi/iasl/Makefile
@@ -22,6 +22,7 @@ SRCS=	\
 	adfile.c \
 	adisasm.c \
 	adwalk.c \
+	ahids.c \
 	ahpredef.c \
 	aslanalyze.c \
 	aslbtypes.c \
@@ -65,6 +66,7 @@ SRCS=	\
 	asluuid.c \
 	aslwalks.c \
 	aslxref.c \
+	cmfsize.c \
 	dtcompile.c \
 	dtexpress.c \
 	dtfield.c \
@@ -147,6 +149,7 @@ SRCS=	\
 	pstree.c \
 	psutils.c \
 	pswalk.c \
+	tbdata.c \
 	tbfadt.c \
 	tbinstal.c \
 	tbprint.c \
-- 
1.8.2.2

